package config

import (
	"cicv-data-closedloop/pjibot_patrol_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/diagnostic_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/geometry_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/nav_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/sensor_msgs"
	"github.com/bluenviron/goroslib/v2/pkg/msgs/std_msgs"
)

var (
	LabelMapTriggerId = make(map[string]string)

	// 1
	TopicOfDiagnostics = "/diagnostics"
	RuleOfDiagnostics  []func(data *diagnostic_msgs.DiagnosticArray) string
	// 2
	TopicOfImu = "/imu"
	RuleOfImu  []func(data *sensor_msgs.Imu) string
	// 3
	TopicOfLocateInfo = "/locate_info"
	RuleOfLocateInfo  []func(data *pjibot_patrol_msgs.LocateInfo) string
	// 4
	TopicOfObstacleDetection = "/obstacle_detection"
	RuleOfObstacleDetection  []func(data *std_msgs.UInt8) string
	// 5
	TopicOfOdom = "/odom"
	RuleOfOdom  []func(data *nav_msgs.Odometry) string
	// 6
	TopicOfSysInfo = "/sys_info"
	RuleOfSysInfo  []func(data *pjibot_patrol_msgs.SysInfo) string
	// 7
	TopicOfRobotPose = "/robot_pose"
	RuleOfRobotPose  []func(data *geometry_msgs.PoseStamped) string
	// 8
	TopicOfTaskFeedbackInfo = "/task_feedback_info"
	RuleOfTaskFeedbackInfo  []func(data *pjibot_patrol_msgs.TaskFeedbackInfo) string
	// 9
	TopicOfWheelOdom = "/wheel_odom"
	RuleOfWheelOdom  []func(data *nav_msgs.Odometry) string
)
