package main

import (
	"cicv-data-closedloop/pjisuv_ticker"
	"fmt"
	"math"
	"sync"
	"time"
)

var (
	Maxlenobj int32 = 0
)

// 定时任务触发器固定的
func Topic() string {
	return pjisuv_ticker.TickerTopic
}

// ******* 禁止存在下划线_
// 触发器标记
func Label() string {
	return "FrontVehicleCutOutFar"
}

func Rule(shareVars *sync.Map) {
	defer func() {
		if r := recover(); r != nil {
			fmt.Println("Recovered from panic:", r)
		}
	}()
	// 1 使用goroutine
	go func(shareVars *sync.Map) {
		// 2 定义触发器的间隔时间
		ticker := time.NewTicker(time.Duration(2) * time.Second)
		defer ticker.Stop()
		// 3 运行一个无限循环
		for {
			select {
			// 定时器触发时执行的代码
			case <-ticker.C:
				FinalCallback(shareVars)

			}
		}
	}(shareVars)
}
func isCuttingIn(ObjectList [][]float32, AngularVelocityZ float64) bool {

	for i, objY := range ObjectList[1] {

		if math.Abs(float64(objY)) >= 1.3 && math.Abs(AngularVelocityZ) <= 0.6 && ObjectList[0][i] >= 2 {
			//fmt.Println(objY)
			for j := 0; j < len(ObjectList[1])-i-1; j++ {
				objX := ObjectList[0][1+i+j]
				if math.Abs(float64(ObjectList[1][1+i+j])) >= 1.7 && math.Abs(AngularVelocityZ) <= 0.6 && objX >= 20 && objX <= 50 {
					//fmt.Println(objX)
					return true
				}
			}
		}
	}
	return false
}
func FinalCallback(shareVars *sync.Map) {
	OutsideWorkshopFlag, ok := shareVars.Load("OutsideWorkshopFlag")
	ObjDicOfTpperception, ok1 := shareVars.Load("objDicOfTpperception")
	ObjDic := ObjDicOfTpperception.(map[uint32][][]float32)
	AngularVelocityZOfCicvLocation, _ := shareVars.Load("AngularVelocityZOfCicvLocation")
	AngularVelocityZ := AngularVelocityZOfCicvLocation.(float64)

	if ok && ok1 && OutsideWorkshopFlag.(bool) == true {
		for _, objValue := range ObjDic {
			Maxlenobj = max(Maxlenobj, int32(len(objValue[0])))
			if len(ObjDic[0]) <= 10 || !isCuttingIn(objValue, AngularVelocityZ) {
				continue
			}
			event_lable := "FrontVehicleCutOutFar"
			fmt.Println(event_lable)
			//ObjDicOfTpperception = make(map[uint32][][]float32)
			pjisuv_ticker.TickerChan <- pjisuv_ticker.TickInfo{FaultLabel: Label(), FaultHappenTime: pjisuv_ticker.GetNowTimeCustom()}
		}

		if Maxlenobj >= 100 {
			ObjDicOfTpperception = make(map[uint32][][]float32)
			shareVars.Store("ObjDicOfTpperception", ObjDicOfTpperception)
			Maxlenobj = 0
		}
	}

}
